import { RpsContext } from 'rpscript-interface';
/** Module for moustache templating
 * @see {@link http://twitter.github.io/hogan.js/|Hogan}
 * @namespace Hogan
 * @example
 * rps install hogan
*/
export default class RPSHogan {
    /**
   * @function hogan
   * @memberof Hogan
   * @example
   * hogan-compile 'template-content' {a:1,b:2}
   *
   * @param {String} template template content.
   * @param {Object} context context to be passed into the template.
   * @param {*} options refer to Hogan.js documentation.
   *
   * @summary hogan :: String → Object → String
   *
  */
    moustacheToHtml(ctx: RpsContext, opts: Object, content?: string, context?: Object): Promise<string | Function>;
}
