"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
let Hogan = require('hogan.js');
const rpscript_interface_1 = require("rpscript-interface");
/** Module for moustache templating
 * @see {@link http://twitter.github.io/hogan.js/|Hogan}
 * @namespace Hogan
 * @example
 * rps install hogan
*/
let RPSHogan = class RPSHogan {
    /**
   * @function hogan
   * @memberof Hogan
   * @example
   * hogan-compile 'template-content' {a:1,b:2}
   *
   * @param {String} template template content.
   * @param {Object} context context to be passed into the template.
   * @param {*} options refer to Hogan.js documentation.
   *
   * @summary hogan :: String → Object → String
   *
  */
    moustacheToHtml(ctx, opts, content, context) {
        return __awaiter(this, void 0, void 0, function* () {
            function compile(content, context) {
                let compiled = Hogan.compile(content, opts);
                if (!context)
                    return function (context) { return compiled.render(context); };
                else
                    return compiled.render(context);
            }
            if (!content)
                return compile;
            else if (!context)
                return compile(content);
            else
                return compile(content, context);
        });
    }
};
__decorate([
    rpscript_interface_1.rpsAction({ verbName: 'hogan' })
], RPSHogan.prototype, "moustacheToHtml", null);
RPSHogan = __decorate([
    rpscript_interface_1.RpsModule("hogan")
], RPSHogan);
exports.default = RPSHogan;
